=== debian/changelog ===
wxmaxima (20.12.1-1) unstable; urgency=medium

  * A new upstream version
  * The debian package now uses GTK3
  * Bumped the standards version to 4.5.0
  * Bumped the debhelper compatibility level (and min version) to 13
  * Removed debian/compat as it no more is needed in comp level 13
  * override-auto-test no honors the nocheck flag
  * Removed an no-more-needed linker flag injection
  * Dropped the workaround for the spurious COPYING file install
  * New build depends for the automatic tests: netcat-openbsd, xvfb,
    debian-file-utils, xauth and appstream-util

 -- Gunter Königsmann <wxmaxima@physikbuch.de>  Mon, 28 Dec 2020 12:15:36 +0100
